#include <hildon-cp-plugin/hildon-cp-plugin-interface.h>
#include <hildon/hildon.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

osso_return_t execute(osso_context_t *osso, gpointer data, gboolean user_activated)
{
	char a = 'y';
	char b = 'y';
	char c = 'y';
	GtkWidget *dialog;
	GtkWidget *btnVisual;
	GtkWidget *btnVibrate;
	GtkWidget *btnSound;
	GtkWidget *slider;
	GtkWidget *lblText;
	GtkAdjustment * adj;
	gdouble sldValue = 5.0;
	gdouble newValue = 0.0;
	char fileContent[64];
	char *fileDouble;
	int i;
	gint response;
	FILE *inputFilePtr;

	/* Create dialog with OK and Cancel buttons. Leave the separator out,
	 * as we do not have any content. */
	dialog = gtk_dialog_new_with_buttons(
		"Call Notify Settings",
		GTK_WINDOW(data),
		GTK_DIALOG_MODAL | GTK_DIALOG_NO_SEPARATOR,
		GTK_STOCK_OK,
		GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL,
		GTK_RESPONSE_CANCEL,
		NULL);

	/* ... add something to the dialog ... */
	btnVisual = (GtkWidget*)hildon_check_button_new(HILDON_SIZE_FULLSCREEN_WIDTH | HILDON_SIZE_FINGER_HEIGHT);
	gtk_button_set_label (GTK_BUTTON (btnVisual), "Visual Notification");

	btnSound = (GtkWidget*)hildon_check_button_new(HILDON_SIZE_FULLSCREEN_WIDTH | HILDON_SIZE_FINGER_HEIGHT);
	gtk_button_set_label (GTK_BUTTON (btnSound), "Sound Notification");

	btnVibrate = (GtkWidget*)hildon_check_button_new(HILDON_SIZE_FULLSCREEN_WIDTH | HILDON_SIZE_FINGER_HEIGHT);
	gtk_button_set_label (GTK_BUTTON (btnVibrate), "Vibrate Notification");

	lblText = (GtkWidget*)gtk_label_new("Please select notification interval:");


	slider = gtk_hscale_new_with_range(0.0, 60.0, 0.1);
	adj = gtk_range_get_adjustment(GTK_RANGE(slider));

	hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnVisual), TRUE);
	hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnSound), TRUE);
	hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnVibrate) , TRUE);

	inputFilePtr = fopen("/home/user/.config/CallNotify/conf.txt", "r");

	if (inputFilePtr != NULL)
	{

		fgets(fileContent, 12,inputFilePtr);


		if (fileContent[0]=='n')
			hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnVisual), FALSE);
		if (fileContent[2]=='n')
			hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnSound), FALSE);
		if (fileContent[4]=='n')
			hildon_check_button_set_active (HILDON_CHECK_BUTTON(btnVibrate) , FALSE);

		(char*)strtok(fileContent, ";");
		(char*)strtok(NULL, ";");
		(char*)strtok(NULL, ";");

		fileDouble = strtok(NULL, ";");

		if (fileDouble)
		{

			// replace , with .
			for (i=0;  i<strlen(fileDouble); i++)
				if (fileDouble[i]==',')
					fileDouble[i] = '.';

			sldValue = g_strtod(fileDouble, NULL);

		}

		fclose(inputFilePtr);

	}

	gtk_adjustment_set_value(adj, sldValue);

	gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),	btnVisual);
	gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),	btnSound);
	gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),	btnVibrate);
	gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),	lblText);
	gtk_container_add(GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),	slider);

	gtk_widget_show_all(dialog);

	/* Wait until user finishes the dialog. */
	response = gtk_dialog_run(GTK_DIALOG(dialog));

	if (response == GTK_RESPONSE_OK)
	{
		/* ... do something with the dialog stuff ... */
		inputFilePtr = fopen("/home/user/.config/CallNotify/conf.txt", "w");

		if (inputFilePtr == NULL)
		{
			mkdir("/home/user/.config/CallNotify", S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
			inputFilePtr = fopen("/home/user/.config/CallNotify/conf.txt", "w");
		}

		if (inputFilePtr != NULL)
		{
			a = hildon_check_button_get_active(HILDON_CHECK_BUTTON(btnVisual)) ? 'y' : 'n';
			b = hildon_check_button_get_active(HILDON_CHECK_BUTTON(btnSound)) ? 'y' : 'n';
			c = hildon_check_button_get_active(HILDON_CHECK_BUTTON(btnVibrate)) ? 'y' : 'n';

			newValue = gtk_adjustment_get_value(adj);

			fprintf(inputFilePtr, "%c;%c;%c;%.1f\n",a,b,c,newValue);
			fclose(inputFilePtr);
		}

	}

	/* Free the dialog (and it's children) */

	gtk_widget_destroy(GTK_WIDGET(dialog));

	return OSSO_OK;
}

osso_return_t save_state(osso_context_t *osso, gpointer data)
{
	/* ... save state ... */

	return OSSO_OK;
}
